import json
import pathlib

import commonmark
import flask

with open(pathlib.Path(__file__).parent / 'config.json') as f:
    CONFIGURATION = json.loads(f.read())

app = flask.Flask(__name__)

def render_markdown_file(name, title):
    try:
        with open(pathlib.Path(CONFIGURATION['directory']) / '{}.md'.format(name), 'r') as f:
            content = commonmark.commonmark(f.read())
    except FileNotFoundError as e:
        flask.abort(404)

    return flask.render_template('page.html', content=content, title=title)

@app.route('/')
def index():
    return render_markdown_file('_index', 'Home')

@app.route('/p/<name>')
def page(name):
    for ch in name:
        if not ch in 'abcdefghijklmnopqrstuvwxyz-0123456789':
            flask.abort(404)

    return render_markdown_file(name, name.replace('-', ' ').title())

